# SwaggerClient-php
Ingram Micro order management API for creating, reading and deleting orders.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 5.0
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen
For more information, please visit [https://developer.ingrammicro.com/contact](https://developer.ingrammicro.com/contact)

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: application
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new Swagger\Client\Api\OrdersApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$ordernumber = "ordernumber_example"; // string | Ingram Micro sales order number
$customer_number = "customer_number_example"; // string | Your unique Ingram Micro customer number
$iso_country_code = "iso_country_code_example"; // string | 2 chars ISO country code
$entry_date = "2020-04-03"; // string | Order entry date (yyyy-mm-dd)

try {
    $result = $apiInstance->deleteOrdersOrderNumber($ordernumber, $customer_number, $iso_country_code, $entry_date);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OrdersApi->deleteOrdersOrderNumber: ', $e->getMessage(), PHP_EOL;
}

// Configure OAuth2 access token for authorization: application
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new Swagger\Client\Api\OrdersApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$customer_number = "customer_number_example"; // string | Your unique Ingram Micro customer number
$isocountrycode = "isocountrycode_example"; // string | 2 char iso country code
$ordernumber = "ordernumber_example"; // string | Ingram sales order number
$customerordernumber = "customerordernumber_example"; // string | Search using your PO/Order number
$orderstatus = "any"; // string | Ingram Micro order status
$startcreatetimestamp = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Search start date/time in UTC format
$endcreatetimestamp = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Search end date/time in UTC format
$pagesize = 56; // int | Number of records required in the call
$pagenumber = 1; // int | the page number reference

try {
    $result = $apiInstance->getOrdersSearch($customer_number, $isocountrycode, $ordernumber, $customerordernumber, $orderstatus, $startcreatetimestamp, $endcreatetimestamp, $pagesize, $pagenumber);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OrdersApi->getOrdersSearch: ', $e->getMessage(), PHP_EOL;
}

// Configure OAuth2 access token for authorization: application
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new Swagger\Client\Api\OrdersApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$ordernumber = "ordernumber_example"; // string | Ingram Micro sales order number
$customernumber = "20-222222"; // string | Your unique Ingram Micro customer number
$isocountrycode = "US"; // string | 2 chars ISO country code
$customerordernumber = "customerordernumber_example"; // string | Your PO/Order Number provide at the time of order creation
$startcreatetimestamp = new \DateTime("2013-10-20"); // \DateTime | Filter start date - format YYYY-MM-DD
$endcreatetimestamp = "endcreatetimestamp_example"; // string | Filter end date - format YYYY-MM-DD

try {
    $result = $apiInstance->getV5OrdersDetails($ordernumber, $customernumber, $isocountrycode, $customerordernumber, $startcreatetimestamp, $endcreatetimestamp);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OrdersApi->getV5OrdersDetails: ', $e->getMessage(), PHP_EOL;
}

// Configure OAuth2 access token for authorization: application
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new Swagger\Client\Api\OrdersApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\OrderCreateRequest(); // \Swagger\Client\Model\OrderCreateRequest | 

try {
    $result = $apiInstance->postV5OrdersCreate($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OrdersApi->postV5OrdersCreate: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OrdersApi* | [**deleteOrdersOrderNumber**](docs/Api/OrdersApi.md#deleteordersordernumber) | **DELETE** /orders/{ordernumber} | Cancel an existing order
*OrdersApi* | [**getOrdersSearch**](docs/Api/OrdersApi.md#getorderssearch) | **GET** /orders/search | Search Your Orders
*OrdersApi* | [**getV5OrdersDetails**](docs/Api/OrdersApi.md#getv5ordersdetails) | **GET** /orders/{ordernumber} | Get order details
*OrdersApi* | [**postV5OrdersCreate**](docs/Api/OrdersApi.md#postv5orderscreate) | **POST** /orders | Create a new order

## Documentation For Models

 - [OrderCancelResponse](docs/Model/OrderCancelResponse.md)
 - [OrderCancelResponseServiceresponse](docs/Model/OrderCancelResponseServiceresponse.md)
 - [OrderCancelResponseServiceresponseResponsepreamble](docs/Model/OrderCancelResponseServiceresponseResponsepreamble.md)
 - [OrderCreateRequest](docs/Model/OrderCreateRequest.md)
 - [OrderCreateRequestOrdercreaterequest](docs/Model/OrderCreateRequestOrdercreaterequest.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetails](docs/Model/OrderCreateRequestOrdercreaterequestOrdercreatedetails.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsEnduser](docs/Model/OrderCreateRequestOrdercreaterequestOrdercreatedetailsEnduser.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsExtendedspecs](docs/Model/OrderCreateRequestOrdercreaterequestOrdercreatedetailsExtendedspecs.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsLines](docs/Model/OrderCreateRequestOrdercreaterequestOrdercreatedetailsLines.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsProductextendedspecs](docs/Model/OrderCreateRequestOrdercreaterequestOrdercreatedetailsProductextendedspecs.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsShiptoaddress](docs/Model/OrderCreateRequestOrdercreaterequestOrdercreatedetailsShiptoaddress.md)
 - [OrderCreateRequestOrdercreaterequestRequestpreamble](docs/Model/OrderCreateRequestOrdercreaterequestRequestpreamble.md)
 - [OrderCreateResponse](docs/Model/OrderCreateResponse.md)
 - [OrderCreateResponseServiceresponse](docs/Model/OrderCreateResponseServiceresponse.md)
 - [OrderCreateResponseServiceresponseLines](docs/Model/OrderCreateResponseServiceresponseLines.md)
 - [OrderCreateResponseServiceresponseOrdercreateresponse](docs/Model/OrderCreateResponseServiceresponseOrdercreateresponse.md)
 - [OrderCreateResponseServiceresponseOrdersummary](docs/Model/OrderCreateResponseServiceresponseOrdersummary.md)
 - [OrderCreateResponseServiceresponseOrdersummaryShiptoaddress](docs/Model/OrderCreateResponseServiceresponseOrdersummaryShiptoaddress.md)
 - [OrderCreateResponseServiceresponseResponsepreamble](docs/Model/OrderCreateResponseServiceresponseResponsepreamble.md)
 - [OrderDetailResponse](docs/Model/OrderDetailResponse.md)
 - [OrderDetailResponseServiceresponse](docs/Model/OrderDetailResponseServiceresponse.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponse](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponse.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseBilltoaddress](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseBilltoaddress.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseCommentlines](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseCommentlines.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseEnduserinfo](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseEnduserinfo.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseExtendedspecs](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseExtendedspecs.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseLines](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseLines.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseMiscfeeline](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseMiscfeeline.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponsePackagedetails](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponsePackagedetails.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseProductextendedspecs](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseProductextendedspecs.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseSerialnumberdetails](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseSerialnumberdetails.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseShipmentdetails](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseShipmentdetails.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseShiptoaddress](docs/Model/OrderDetailResponseServiceresponseOrderdetailresponseShiptoaddress.md)
 - [OrderSearchResponse](docs/Model/OrderSearchResponse.md)
 - [OrderSearchResponseServiceResponse](docs/Model/OrderSearchResponseServiceResponse.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponse](docs/Model/OrderSearchResponseServiceResponseOrdersearchresponse.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseLinks](docs/Model/OrderSearchResponseServiceResponseOrdersearchresponseLinks.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseLinks1](docs/Model/OrderSearchResponseServiceResponseOrdersearchresponseLinks1.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseOrders](docs/Model/OrderSearchResponseServiceResponseOrdersearchresponseOrders.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseSuborders](docs/Model/OrderSearchResponseServiceResponseOrdersearchresponseSuborders.md)
 - [OrderSearchResponseServiceResponseResponsepreamble](docs/Model/OrderSearchResponseServiceResponseResponsepreamble.md)

## Documentation For Authorization


## application

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - ****: 


## Author



