<?php
/**
 * OrdersApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Order Management APIs
 *
 * Ingram Micro order management API for creating, reading and deleting orders.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * OrdersApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class OrdersApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation deleteOrdersOrderNumber
     *
     * Cancel an existing order
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $iso_country_code 2 chars ISO country code (required)
     * @param  string $entry_date Order entry date (yyyy-mm-dd) (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\OrderCancelResponse
     */
    public function deleteOrdersOrderNumber($ordernumber, $customer_number, $iso_country_code, $entry_date)
    {
        list($response) = $this->deleteOrdersOrderNumberWithHttpInfo($ordernumber, $customer_number, $iso_country_code, $entry_date);
        return $response;
    }

    /**
     * Operation deleteOrdersOrderNumberWithHttpInfo
     *
     * Cancel an existing order
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $iso_country_code 2 chars ISO country code (required)
     * @param  string $entry_date Order entry date (yyyy-mm-dd) (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\OrderCancelResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteOrdersOrderNumberWithHttpInfo($ordernumber, $customer_number, $iso_country_code, $entry_date)
    {
        $returnType = '\Swagger\Client\Model\OrderCancelResponse';
        $request = $this->deleteOrdersOrderNumberRequest($ordernumber, $customer_number, $iso_country_code, $entry_date);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\OrderCancelResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deleteOrdersOrderNumberAsync
     *
     * Cancel an existing order
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $iso_country_code 2 chars ISO country code (required)
     * @param  string $entry_date Order entry date (yyyy-mm-dd) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteOrdersOrderNumberAsync($ordernumber, $customer_number, $iso_country_code, $entry_date)
    {
        return $this->deleteOrdersOrderNumberAsyncWithHttpInfo($ordernumber, $customer_number, $iso_country_code, $entry_date)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteOrdersOrderNumberAsyncWithHttpInfo
     *
     * Cancel an existing order
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $iso_country_code 2 chars ISO country code (required)
     * @param  string $entry_date Order entry date (yyyy-mm-dd) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteOrdersOrderNumberAsyncWithHttpInfo($ordernumber, $customer_number, $iso_country_code, $entry_date)
    {
        $returnType = '\Swagger\Client\Model\OrderCancelResponse';
        $request = $this->deleteOrdersOrderNumberRequest($ordernumber, $customer_number, $iso_country_code, $entry_date);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteOrdersOrderNumber'
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $iso_country_code 2 chars ISO country code (required)
     * @param  string $entry_date Order entry date (yyyy-mm-dd) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteOrdersOrderNumberRequest($ordernumber, $customer_number, $iso_country_code, $entry_date)
    {
        // verify the required parameter 'ordernumber' is set
        if ($ordernumber === null || (is_array($ordernumber) && count($ordernumber) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $ordernumber when calling deleteOrdersOrderNumber'
            );
        }
        // verify the required parameter 'customer_number' is set
        if ($customer_number === null || (is_array($customer_number) && count($customer_number) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customer_number when calling deleteOrdersOrderNumber'
            );
        }
        // verify the required parameter 'iso_country_code' is set
        if ($iso_country_code === null || (is_array($iso_country_code) && count($iso_country_code) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $iso_country_code when calling deleteOrdersOrderNumber'
            );
        }
        // verify the required parameter 'entry_date' is set
        if ($entry_date === null || (is_array($entry_date) && count($entry_date) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $entry_date when calling deleteOrdersOrderNumber'
            );
        }

        $resourcePath = '/orders/{ordernumber}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($customer_number !== null) {
            $queryParams['customerNumber'] = ObjectSerializer::toQueryValue($customer_number);
        }
        // query params
        if ($iso_country_code !== null) {
            $queryParams['isoCountryCode'] = ObjectSerializer::toQueryValue($iso_country_code);
        }
        // query params
        if ($entry_date !== null) {
            $queryParams['entryDate'] = ObjectSerializer::toQueryValue($entry_date);
        }

        // path params
        if ($ordernumber !== null) {
            $resourcePath = str_replace(
                '{' . 'ordernumber' . '}',
                ObjectSerializer::toPathValue($ordernumber),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getOrdersSearch
     *
     * Search Your Orders
     *
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 char iso country code (required)
     * @param  string $ordernumber Ingram sales order number (optional)
     * @param  string $customerordernumber Search using your PO/Order number (optional)
     * @param  string $orderstatus Ingram Micro order status (optional, default to any)
     * @param  \DateTime $startcreatetimestamp Search start date/time in UTC format (optional)
     * @param  \DateTime $endcreatetimestamp Search end date/time in UTC format (optional)
     * @param  int $pagesize Number of records required in the call (optional)
     * @param  int $pagenumber the page number reference (optional, default to 1)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\OrderSearchResponse
     */
    public function getOrdersSearch($customer_number, $isocountrycode, $ordernumber = null, $customerordernumber = null, $orderstatus = 'any', $startcreatetimestamp = null, $endcreatetimestamp = null, $pagesize = null, $pagenumber = '1')
    {
        list($response) = $this->getOrdersSearchWithHttpInfo($customer_number, $isocountrycode, $ordernumber, $customerordernumber, $orderstatus, $startcreatetimestamp, $endcreatetimestamp, $pagesize, $pagenumber);
        return $response;
    }

    /**
     * Operation getOrdersSearchWithHttpInfo
     *
     * Search Your Orders
     *
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 char iso country code (required)
     * @param  string $ordernumber Ingram sales order number (optional)
     * @param  string $customerordernumber Search using your PO/Order number (optional)
     * @param  string $orderstatus Ingram Micro order status (optional, default to any)
     * @param  \DateTime $startcreatetimestamp Search start date/time in UTC format (optional)
     * @param  \DateTime $endcreatetimestamp Search end date/time in UTC format (optional)
     * @param  int $pagesize Number of records required in the call (optional)
     * @param  int $pagenumber the page number reference (optional, default to 1)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\OrderSearchResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getOrdersSearchWithHttpInfo($customer_number, $isocountrycode, $ordernumber = null, $customerordernumber = null, $orderstatus = 'any', $startcreatetimestamp = null, $endcreatetimestamp = null, $pagesize = null, $pagenumber = '1')
    {
        $returnType = '\Swagger\Client\Model\OrderSearchResponse';
        $request = $this->getOrdersSearchRequest($customer_number, $isocountrycode, $ordernumber, $customerordernumber, $orderstatus, $startcreatetimestamp, $endcreatetimestamp, $pagesize, $pagenumber);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\OrderSearchResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getOrdersSearchAsync
     *
     * Search Your Orders
     *
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 char iso country code (required)
     * @param  string $ordernumber Ingram sales order number (optional)
     * @param  string $customerordernumber Search using your PO/Order number (optional)
     * @param  string $orderstatus Ingram Micro order status (optional, default to any)
     * @param  \DateTime $startcreatetimestamp Search start date/time in UTC format (optional)
     * @param  \DateTime $endcreatetimestamp Search end date/time in UTC format (optional)
     * @param  int $pagesize Number of records required in the call (optional)
     * @param  int $pagenumber the page number reference (optional, default to 1)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getOrdersSearchAsync($customer_number, $isocountrycode, $ordernumber = null, $customerordernumber = null, $orderstatus = 'any', $startcreatetimestamp = null, $endcreatetimestamp = null, $pagesize = null, $pagenumber = '1')
    {
        return $this->getOrdersSearchAsyncWithHttpInfo($customer_number, $isocountrycode, $ordernumber, $customerordernumber, $orderstatus, $startcreatetimestamp, $endcreatetimestamp, $pagesize, $pagenumber)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getOrdersSearchAsyncWithHttpInfo
     *
     * Search Your Orders
     *
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 char iso country code (required)
     * @param  string $ordernumber Ingram sales order number (optional)
     * @param  string $customerordernumber Search using your PO/Order number (optional)
     * @param  string $orderstatus Ingram Micro order status (optional, default to any)
     * @param  \DateTime $startcreatetimestamp Search start date/time in UTC format (optional)
     * @param  \DateTime $endcreatetimestamp Search end date/time in UTC format (optional)
     * @param  int $pagesize Number of records required in the call (optional)
     * @param  int $pagenumber the page number reference (optional, default to 1)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getOrdersSearchAsyncWithHttpInfo($customer_number, $isocountrycode, $ordernumber = null, $customerordernumber = null, $orderstatus = 'any', $startcreatetimestamp = null, $endcreatetimestamp = null, $pagesize = null, $pagenumber = '1')
    {
        $returnType = '\Swagger\Client\Model\OrderSearchResponse';
        $request = $this->getOrdersSearchRequest($customer_number, $isocountrycode, $ordernumber, $customerordernumber, $orderstatus, $startcreatetimestamp, $endcreatetimestamp, $pagesize, $pagenumber);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getOrdersSearch'
     *
     * @param  string $customer_number Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 char iso country code (required)
     * @param  string $ordernumber Ingram sales order number (optional)
     * @param  string $customerordernumber Search using your PO/Order number (optional)
     * @param  string $orderstatus Ingram Micro order status (optional, default to any)
     * @param  \DateTime $startcreatetimestamp Search start date/time in UTC format (optional)
     * @param  \DateTime $endcreatetimestamp Search end date/time in UTC format (optional)
     * @param  int $pagesize Number of records required in the call (optional)
     * @param  int $pagenumber the page number reference (optional, default to 1)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getOrdersSearchRequest($customer_number, $isocountrycode, $ordernumber = null, $customerordernumber = null, $orderstatus = 'any', $startcreatetimestamp = null, $endcreatetimestamp = null, $pagesize = null, $pagenumber = '1')
    {
        // verify the required parameter 'customer_number' is set
        if ($customer_number === null || (is_array($customer_number) && count($customer_number) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customer_number when calling getOrdersSearch'
            );
        }
        // verify the required parameter 'isocountrycode' is set
        if ($isocountrycode === null || (is_array($isocountrycode) && count($isocountrycode) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $isocountrycode when calling getOrdersSearch'
            );
        }

        $resourcePath = '/orders/search';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($customer_number !== null) {
            $queryParams['customerNumber'] = ObjectSerializer::toQueryValue($customer_number);
        }
        // query params
        if ($isocountrycode !== null) {
            $queryParams['isocountrycode'] = ObjectSerializer::toQueryValue($isocountrycode);
        }
        // query params
        if ($ordernumber !== null) {
            $queryParams['ordernumber'] = ObjectSerializer::toQueryValue($ordernumber);
        }
        // query params
        if ($customerordernumber !== null) {
            $queryParams['customerordernumber'] = ObjectSerializer::toQueryValue($customerordernumber);
        }
        // query params
        if ($orderstatus !== null) {
            $queryParams['orderstatus'] = ObjectSerializer::toQueryValue($orderstatus);
        }
        // query params
        if ($startcreatetimestamp !== null) {
            $queryParams['startcreatetimestamp'] = ObjectSerializer::toQueryValue($startcreatetimestamp);
        }
        // query params
        if ($endcreatetimestamp !== null) {
            $queryParams['endcreatetimestamp'] = ObjectSerializer::toQueryValue($endcreatetimestamp);
        }
        // query params
        if ($pagesize !== null) {
            $queryParams['pagesize'] = ObjectSerializer::toQueryValue($pagesize);
        }
        // query params
        if ($pagenumber !== null) {
            $queryParams['pagenumber'] = ObjectSerializer::toQueryValue($pagenumber);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getV5OrdersDetails
     *
     * Get order details
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customernumber Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 chars ISO country code (required)
     * @param  string $customerordernumber Your PO/Order Number provide at the time of order creation (optional)
     * @param  \DateTime $startcreatetimestamp Filter start date - format YYYY-MM-DD (optional)
     * @param  string $endcreatetimestamp Filter end date - format YYYY-MM-DD (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\OrderDetailResponse
     */
    public function getV5OrdersDetails($ordernumber, $customernumber, $isocountrycode, $customerordernumber = null, $startcreatetimestamp = null, $endcreatetimestamp = null)
    {
        list($response) = $this->getV5OrdersDetailsWithHttpInfo($ordernumber, $customernumber, $isocountrycode, $customerordernumber, $startcreatetimestamp, $endcreatetimestamp);
        return $response;
    }

    /**
     * Operation getV5OrdersDetailsWithHttpInfo
     *
     * Get order details
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customernumber Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 chars ISO country code (required)
     * @param  string $customerordernumber Your PO/Order Number provide at the time of order creation (optional)
     * @param  \DateTime $startcreatetimestamp Filter start date - format YYYY-MM-DD (optional)
     * @param  string $endcreatetimestamp Filter end date - format YYYY-MM-DD (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\OrderDetailResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getV5OrdersDetailsWithHttpInfo($ordernumber, $customernumber, $isocountrycode, $customerordernumber = null, $startcreatetimestamp = null, $endcreatetimestamp = null)
    {
        $returnType = '\Swagger\Client\Model\OrderDetailResponse';
        $request = $this->getV5OrdersDetailsRequest($ordernumber, $customernumber, $isocountrycode, $customerordernumber, $startcreatetimestamp, $endcreatetimestamp);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\OrderDetailResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getV5OrdersDetailsAsync
     *
     * Get order details
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customernumber Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 chars ISO country code (required)
     * @param  string $customerordernumber Your PO/Order Number provide at the time of order creation (optional)
     * @param  \DateTime $startcreatetimestamp Filter start date - format YYYY-MM-DD (optional)
     * @param  string $endcreatetimestamp Filter end date - format YYYY-MM-DD (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getV5OrdersDetailsAsync($ordernumber, $customernumber, $isocountrycode, $customerordernumber = null, $startcreatetimestamp = null, $endcreatetimestamp = null)
    {
        return $this->getV5OrdersDetailsAsyncWithHttpInfo($ordernumber, $customernumber, $isocountrycode, $customerordernumber, $startcreatetimestamp, $endcreatetimestamp)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getV5OrdersDetailsAsyncWithHttpInfo
     *
     * Get order details
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customernumber Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 chars ISO country code (required)
     * @param  string $customerordernumber Your PO/Order Number provide at the time of order creation (optional)
     * @param  \DateTime $startcreatetimestamp Filter start date - format YYYY-MM-DD (optional)
     * @param  string $endcreatetimestamp Filter end date - format YYYY-MM-DD (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getV5OrdersDetailsAsyncWithHttpInfo($ordernumber, $customernumber, $isocountrycode, $customerordernumber = null, $startcreatetimestamp = null, $endcreatetimestamp = null)
    {
        $returnType = '\Swagger\Client\Model\OrderDetailResponse';
        $request = $this->getV5OrdersDetailsRequest($ordernumber, $customernumber, $isocountrycode, $customerordernumber, $startcreatetimestamp, $endcreatetimestamp);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getV5OrdersDetails'
     *
     * @param  string $ordernumber Ingram Micro sales order number (required)
     * @param  string $customernumber Your unique Ingram Micro customer number (required)
     * @param  string $isocountrycode 2 chars ISO country code (required)
     * @param  string $customerordernumber Your PO/Order Number provide at the time of order creation (optional)
     * @param  \DateTime $startcreatetimestamp Filter start date - format YYYY-MM-DD (optional)
     * @param  string $endcreatetimestamp Filter end date - format YYYY-MM-DD (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getV5OrdersDetailsRequest($ordernumber, $customernumber, $isocountrycode, $customerordernumber = null, $startcreatetimestamp = null, $endcreatetimestamp = null)
    {
        // verify the required parameter 'ordernumber' is set
        if ($ordernumber === null || (is_array($ordernumber) && count($ordernumber) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $ordernumber when calling getV5OrdersDetails'
            );
        }
        // verify the required parameter 'customernumber' is set
        if ($customernumber === null || (is_array($customernumber) && count($customernumber) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customernumber when calling getV5OrdersDetails'
            );
        }
        // verify the required parameter 'isocountrycode' is set
        if ($isocountrycode === null || (is_array($isocountrycode) && count($isocountrycode) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $isocountrycode when calling getV5OrdersDetails'
            );
        }

        $resourcePath = '/orders/{ordernumber}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($customernumber !== null) {
            $queryParams['customernumber'] = ObjectSerializer::toQueryValue($customernumber);
        }
        // query params
        if ($isocountrycode !== null) {
            $queryParams['isocountrycode'] = ObjectSerializer::toQueryValue($isocountrycode);
        }
        // query params
        if ($customerordernumber !== null) {
            $queryParams['customerordernumber'] = ObjectSerializer::toQueryValue($customerordernumber);
        }
        // query params
        if ($startcreatetimestamp !== null) {
            $queryParams['startcreatetimestamp'] = ObjectSerializer::toQueryValue($startcreatetimestamp);
        }
        // query params
        if ($endcreatetimestamp !== null) {
            $queryParams['endcreatetimestamp'] = ObjectSerializer::toQueryValue($endcreatetimestamp);
        }

        // path params
        if ($ordernumber !== null) {
            $resourcePath = str_replace(
                '{' . 'ordernumber' . '}',
                ObjectSerializer::toPathValue($ordernumber),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postV5OrdersCreate
     *
     * Create a new order
     *
     * @param  \Swagger\Client\Model\OrderCreateRequest $body body (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\OrderCreateResponse
     */
    public function postV5OrdersCreate($body = null)
    {
        list($response) = $this->postV5OrdersCreateWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation postV5OrdersCreateWithHttpInfo
     *
     * Create a new order
     *
     * @param  \Swagger\Client\Model\OrderCreateRequest $body (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\OrderCreateResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function postV5OrdersCreateWithHttpInfo($body = null)
    {
        $returnType = '\Swagger\Client\Model\OrderCreateResponse';
        $request = $this->postV5OrdersCreateRequest($body);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\OrderCreateResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postV5OrdersCreateAsync
     *
     * Create a new order
     *
     * @param  \Swagger\Client\Model\OrderCreateRequest $body (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postV5OrdersCreateAsync($body = null)
    {
        return $this->postV5OrdersCreateAsyncWithHttpInfo($body)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postV5OrdersCreateAsyncWithHttpInfo
     *
     * Create a new order
     *
     * @param  \Swagger\Client\Model\OrderCreateRequest $body (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postV5OrdersCreateAsyncWithHttpInfo($body = null)
    {
        $returnType = '\Swagger\Client\Model\OrderCreateResponse';
        $request = $this->postV5OrdersCreateRequest($body);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postV5OrdersCreate'
     *
     * @param  \Swagger\Client\Model\OrderCreateRequest $body (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postV5OrdersCreateRequest($body = null)
    {

        $resourcePath = '/orders';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
